#lang sicp

(define (improve guess x)
  (/ (+ (/ x guess guess)
        (* 2 guess))
     3))

(define (good-enough? guess x)
  (< (abs (- (improve guess x) guess)) 0.0001))

(define (cbrt-iter guess x)
  (if (good-enough? guess x)
      guess
      (cbrt-iter (improve guess x)
                 x)))

(define (cube-root x)
  (cbrt-iter 1.0 x))
